﻿using System.Linq;
using System.Windows.Controls;
using Telerik.Windows.Data;
using SilverlightApplication1.Web;
using System.ServiceModel.DomainServices.Client;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            var context = new NorthwindDomainContext();
            var query = context.GetOrder_DetailsQuery().OrderBy(o => o.OrderID);
            query.IncludeTotalCount = true;
            var view = new VirtualQueryableCollectionView() { LoadSize = 10, VirtualItemCount = 100 };
            view.ItemsLoading += (s, e) =>
            {
                context.Load<Order_Detail>(query.Skip(e.StartIndex).Take(e.ItemCount)).Completed += (sender, args) =>
                {
                    var lo = (LoadOperation)sender;
                    if (lo.TotalEntityCount != -1 && lo.TotalEntityCount != view.VirtualItemCount)
                    {
                        view.VirtualItemCount = lo.TotalEntityCount;
                    }
                    view.Load(e.StartIndex, lo.Entities);
                };
            };
            DataContext = view;

        }
    }
}
